package com.logicbig.example;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;

@Entity
@NamedEntityGraph(name = "graph.module.projects.contractors",
        attributeNodes = @NamedAttributeNode(value = "projects", subgraph = "projects.contractors"),
        subgraphs = @NamedSubgraph(name = "projects.contractors",
                attributeNodes = @NamedAttributeNode(value = "contractors")))
public class TradingModule {
    @Id
    @GeneratedValue
    private int id;
    private String name;
    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    private Set<Project> projects;

    public int getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Set<Project> getProjects() {
        return projects;
    }

    public void addProject(Project project) {
        if (projects == null) {
            projects = new HashSet<>();
        }
        projects.add(project);
    }
}